///////////////////////////////////////////////////////////////////////////
// SHARP
///////////////////////////////////////////////////////////////////////////
#include "mta-helper.fx"
//--------------------------------------------------------------------------------------
// Textures
//--------------------------------------------------------------------------------------
texture sTex0 :TEX0;

//--------------------------------------------------------------------------------------
// Sampler Inputs
//--------------------------------------------------------------------------------------

sampler2D SamplerColor = sampler_state
{
	Texture   = (sTex0);
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;//NONE;
	AddressU  = Clamp;
	AddressV  = Clamp;
	SRGBTexture=FALSE;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

sampler2D InputSampler = sampler_state
{
    Texture = (sTex0);
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = POINT;
    AddressU   = Clamp;
	AddressV   = Clamp;
	SRGBTexture=FALSE;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

struct VSInput
{
    float3 Position : POSITION0;
    float2 TexCoord : TEXCOORD0;
};

struct PSInput
{
    float4 Position : POSITION0;
    float2 TexCoord : TEXCOORD0;
	float4 interpolatorA : TEXCOORD1;
	float4 interpolatorB : TEXCOORD2;
	float4 interpolatorC : TEXCOORD3;	
};
 
//---------------------------------------------------------------------
//
//---------------------------------------------------------------------
float2 texel = {0.0009765625,0.00130208333333333333333333333333};
float2 fViewportSize = float2(800, 600);
static float2 sPixelSize = float2(1 / fViewportSize.x, 1 / fViewportSize.y);

PSInput vs_sharp(VSInput VS)
{
    PSInput PS = (PSInput)0;
    PS.Position = mul(float4(VS.Position, 1), gWorldViewProjection);
    PS.TexCoord = VS.TexCoord;
	
    return PS;
}

//---------------------------------------------------------------------
//
//---------------------------------------------------------------------


float4 ps_sharp(PSInput PS) : COLOR0
{
	float3 c = tex2D(SamplerColor, PS.TexCoord).rgb;
	float2 p = sPixelSize; // ( texel.xy ) * 0.5*1.00;	

    float3 bl = tex2D(SamplerColor, PS.TexCoord + float2(0.5 * p.x,-p.y * 0.07)).rgb;
    bl += tex2D(SamplerColor, PS.TexCoord + float2(0.07 * -p.x,0.5 * -p.y)).rgb;
    bl += tex2D(SamplerColor, PS.TexCoord + float2(0.07 * p.x,0.5 * p.y)).rgb;
    bl += tex2D(SamplerColor, PS.TexCoord + float2(0.5 * -p.x,p.y * 0.07)).rgb;
    bl /= 4.0;

	float3 sharp = c-bl;
	float sh = dot(sharp, 0.08);
	      sh = clamp(sh, -0.5, 0.5);
	
	float3 color = tex2Dlod(SamplerColor, float4(PS.TexCoord, 0.0, 0.0)).rgb+sh;
	return float4(color, 1.0);
}


//---------------------------------------------------------------------
//
//---------------------------------------------------------------------
technique tec
{
  pass P0
  {
		VertexShader = compile vs_3_0 vs_sharp();
		PixelShader  = compile ps_3_0 ps_sharp();

	}

}

/**/